  OPTION EXPLICIT
  OPTION DEFAULT NONE
  DIM a$,b$
  DIM as Integer aa,bb,PM1,PM2,PM3,d1,d2,d3,d4,d5,d6,z,n,cs,css
  Open "COM1:9600" As #1
  
  Do
    a$ = INPUT$(1,#1)
    b$ = b$ + a$
    IF Len(b$) = 32 Then  ' valid data packets contain 32 characters
      decode
      z = asc(mid$(b$,n,1)) + asc(mid$(b$,n,1)) ' z checks if data is duplicated
      b$ = "" 'clear b$
	  PRINT "PM1 = ", PM1
	  PRINT "PM2.5 = " PM2   
	  PRINT "PM10 = " PM3 
	  PRINT STR$(d1) + " particles with diameter > 0.3um "
	  PRINT STR$(d2) + " particles with diameter > 0.5um "
	  PRINT STR$(d3) + " particles with diameter > 1um " 
	  PRINT STR$(d4) + " particles with diameter > 2.5"
	  PRINT STR$(d5) + " particles with diameter > 5um "
	  PRINT STR$(d6) + " particles with diameter > 10um "
	  
    End IF
  Loop
  
sub decode
'for n = 1 to 32
 '  print asc(mid$(b$,n,1)); : print ",";  'Debug use to see the data
'next n
print
  IF left$(b$,2) = "BM" then ' Only proceed if probable Valid data is received
    aa = asc(mid$(b$,3)) 'Should be 0
    bb = asc(mid$(b$,4)) 'Should be 28
    if aa + bb = 28 then ' data length is correct we probably have valid data
      css =asc(mid$(b$,31,1))*256+asc(mid$(b$,32,1)) ' Calculate Checksum
      for n = 1 to 30
        cs = cs + asc(mid$(b$,n,1))
      next n
      If cs = css then   'CHECKSUM correct we can use the data
	 ' print "Checksum OK"  'debug use
       cs = 0
        'Only need values from Data7 high to Data12 low
        PM1= asc(mid$(b$,11)) * 256 + asc(mid$(b$,12))   'PM1.0 concentration unit  μg/m3（under atmospheric environment）
        PM2 = asc(mid$(b$,13)) * 256 + asc(mid$(b$,14))  'PM2.5 concentration unit  μg/m3（under atmospheric environment）
        PM3 =  asc(mid$(b$,15)) * 256 + asc(mid$(b$,16)) 'PM10  concentration unit  μg/m3(under atmospheric environment)
        d1 =   asc(mid$(b$,17)) * 256 + asc(mid$(b$,18)) 'Number of particles with diameter > 0.3um in 0.1L of air
        d2 =   asc(mid$(b$,19)) * 256 + asc(mid$(b$,20)) 'Number of particles with diameter > 0.5um in 0.1L of air
        d3 =   asc(mid$(b$,21)) * 256 + asc(mid$(b$,22)) 'Number of particles with diameter > 1.0um in 0.1L of air
        d4 =   asc(mid$(b$,23)) * 256 + asc(mid$(b$,24)) 'Number of particles with diameter > 2.5um in 0.1L of air
        d5 =   asc(mid$(b$,25)) * 256 + asc(mid$(b$,26)) 'Number of particles with diameter > 5.0um in 0.1L of air
        d6 =   asc(mid$(b$,27)) * 256 + asc(mid$(b$,28)) 'Number of particles with diameter > 10um in 0.1L of air
      END IF
    END IF
    if z = asc(mid$(b$,n,1)) + asc(mid$(b$,n,1))then END SUB ' if data is the same as previous data then disregard and do nothing with the data
END SUB
    
    
